---
title: element()
slug: Web/CSS/element()
tags:
  - CSS
  - CSS Function
  - CSS4-images
  - Function
  - Layout
  - Reference
  - Web
---
<div>{{CSSRef}}{{SeeCompatTable}}</div>

<p>The <strong><code>element()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> defines an {{cssxref("&lt;image&gt;")}} value generated from an arbitrary HTML element. This image is live, meaning that if the HTML element is changed, the CSS properties using the resulting value are automatically updated.</p>

<p>A particularly useful scenario for using this would be to render an image in an HTML {{HTMLElement("canvas")}} element, then use that as a background.</p>

<p>On Gecko browsers, you can use the non-standard {{domxref("document.mozSetImageElement()")}} method to change the element being used as the background for a given CSS background element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">element(<var>id</var>)</pre>

<p>where:</p>

<dl>
 <dt><var>id</var></dt>
 <dd>The ID of an element to use as the background, specified using the HTML attribute #<em>id</em> on the element.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>These examples can be <a href="/samples/cssref/moz-element.html" title="https://developer.mozilla.org/samples/cssref/moz-element.html">viewed live</a> in builds of Firefox that support <code>-moz-element()</code>.</p>

<h3 id="A_somewhat_realistic_example">A somewhat realistic example</h3>

<p>This example uses a hidden {{HTMLElement("div")}} as a background. The background element uses a gradient, but also includes text that is rendered as part of the background.</p>

<pre class="brush: html notranslate">&lt;div style="width:400px; height:400px; background:-moz-element(#myBackground1) no-repeat;"&gt;
  &lt;p&gt;This box uses the element with the #myBackground1 ID as its background!&lt;/p&gt;
&lt;/div&gt;

&lt;div style="overflow:hidden; height:0;"&gt;
  &lt;div id="myBackground1" style="width:1024px; height:1024px; background-image: linear-gradient(to right, red, orange, yellow, white);"&gt;
  &lt;p style="transform-origin:0 0; transform: rotate(45deg); color:white;"&gt;This text is part of the background. Cool, huh?&lt;/p&gt;
  &lt;/div&gt;
&lt;/div&gt;</pre>

<p>The {{HTMLElement("div")}} element with the ID "myBackground1" is used as the background for the content including the paragraph "This box uses the element with the #myBackground1 ID as its background!".</p>

<p><img alt="example1.png" class="default internal" src="/@api/deki/files/4624/=example1.png"></p>

<h3 id="A_somewhat_more_bizarre_example">A somewhat more bizarre example</h3>

<p>This example uses a hidden {{HTMLElement("button")}} element in a repeating pattern as its background. This demonstrates that you can use arbitrary elements as background, but doesn't necessarily demonstrate good design practices.</p>

<pre class="brush: html notranslate">&lt;div style="width:400px; height:100px; background:-moz-element(#myBackground2);"&gt;
&lt;/div&gt;

&lt;div style="overflow:hidden; height:0;"&gt;
  &lt;button id="myBackground2" type="button"&gt;Evil button!&lt;/button&gt;
&lt;/div&gt;
</pre>

<p><img alt="example2.png" class="default internal" src="/@api/deki/files/4625/=example2.png"></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Images', '#element-notation', 'Using Elements as Images: the element() notation')}}</td>
   <td>{{Spec2('CSS4 Images')}}</td>
   <td>Deferred from CSS3 Images.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.types.image.element")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("_image", "image()")}}</li>
 <li>{{cssxref("image-set", "image-set()")}}</li>
 <li>{{cssxref("&lt;image&gt;")}}</li>
 <li>{{cssxref("&lt;gradient&gt;")}}</li>
 <li>{{cssxref("element()")}}</li>
 <li>{{cssxref("cross-fade")}}</li>
 <li>{{domxref("document.mozSetImageElement()")}}</li>
</ul>
